diff --git a/src/main/java/net/minecraft/core/block/BlockRope.java b/src/main/java/net/minecraft/core/block/BlockRope.java
new file mode 100644
index 000000000..2459ac1d4
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockRope.java
@@ -0,0 +1,68 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+
+public class BlockRope
+    extends Block {
+    public BlockRope(String key, int id) {
+        super(key, id, Material.cloth);
+    }
+
+    @Override
+    public boolean renderAsNormalBlock() {
+        return false;
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isClimbable(World world, int x, int y, int z) {
+        return true;
+    }
+
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z) {
+        return null;
+    }
+
+    @Override
+    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    {
+        boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == this.id;
+        boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == this.id;
+        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == this.id;
+        boolean hasBlockPosY = world.getBlockId(x, y + 1, z) == this.id || world.isBlockOpaqueCube(x, y + 1, z);
+        boolean hasBlockNegZ = world.getBlockId(x, y, z - 1) == this.id;
+        boolean hasBlockPosZ = world.getBlockId(x, y, z + 1) == this.id;
+
+        float minX = 5 / 16.0f;
+        float maxX = 11 / 16.0f;
+        float minY = 5 / 16.0f;
+        float maxY = 11 / 16.0f;
+        float minZ = 5 / 16.0f;
+        float maxZ = 11 / 16.0f;
+
+        if (hasBlockNegX) minX = 0;
+        if (hasBlockPosX) maxX = 1;
+        if (hasBlockNegY) minY = 0;
+        if (hasBlockPosY) maxY = 1;
+        if (hasBlockNegZ) minZ = 0;
+        if (hasBlockPosZ) maxZ = 1;
+
+        setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+        return new ItemStack[] { new ItemStack(Item.rope) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingOak.java b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
index 51f106945..ed366e8f9 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCaatinga;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
@@ -22,8 +23,8 @@ public class BlockSaplingOak extends BlockSaplingBase
     @Override
 	public void growTree(World world, int i, int j, int k, Random random)
     {
-    	Object treeBig  = new WorldFeatureTreeFancy(Block.leavesOak.id, Block.logOak.id);
-        Object treeSmall = new WorldFeatureTree(Block.leavesOak.id, Block.logOak.id, 4);
+    	Object treeBig = new WorldFeatureTreeCaatinga(Block.leavesOak.id, Block.logOak.id);
+        Object treeSmall = new WorldFeatureTreeCaatinga(Block.leavesOak.id, Block.logOak.id);
     	world.setBlock(i, j, k, 0);
 
         if(!((WorldFeature) (treeSmall)).generate(world, random, i, j, k))
diff --git a/src/main/java/net/minecraft/core/block/BlockSpikes.java b/src/main/java/net/minecraft/core/block/BlockSpikes.java
index 2223c0c3a..7d39736bb 100644
--- a/src/main/java/net/minecraft/core/block/BlockSpikes.java
+++ b/src/main/java/net/minecraft/core/block/BlockSpikes.java
@@ -89,7 +89,7 @@ public class BlockSpikes extends BlockCobweb
     }
 
     @Override
-    public boolean collidesWithEntity(Entity entity) {
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
         return !(entity instanceof EntityItem);
     }
     
diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoorPainted.java b/src/main/java/net/minecraft/core/block/BlockTrapDoorPainted.java
new file mode 100644
index 000000000..ca1f87515
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockTrapDoorPainted.java
@@ -0,0 +1,33 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class BlockTrapDoorPainted extends BlockTrapDoor{
+    public BlockTrapDoorPainted(String key, int id, Material material) {
+        super(key, id, material, false);
+    }
+    @Override
+    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+        int meta = world.getBlockMetadata(x, y, z);
+        int colorBits = meta & 0xF0;
+        meta = getMetaForDirection(entity.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
+        if(entity.getVerticalPlacementDirection(side, sideHeight) == Direction.UP) {
+            meta |= 8;
+        }
+        meta |= colorBits;
+        world.setBlockMetadata(x, y, z, meta);
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    {
+        return new ItemStack[] { new ItemStack(Block.trapdoorPlanksOakPainted, 1, (meta >> 4 & 0xF) << 4) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 735a94100..a21ea60a5 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -162,6 +162,6 @@ public class TileEntity
         addMapping(TileEntityFlag.class, "Flag");
         addMapping(TileEntitySeat.class, "Seat");
         addMapping(TileEntityFlowerJar.class, "FlowerJar");
-
+        addMapping(TileEntityMeshGold.class, "MeshGold");
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
new file mode 100644
index 000000000..67a716780
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -0,0 +1,61 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet140TileEntityData;
+import org.jetbrains.annotations.Nullable;
+
+public class TileEntityMeshGold extends TileEntity{
+    @Nullable
+    public ItemStack filterItem;
+    public int ticksRan = 0;
+    public TileEntityMeshGold() {
+    }
+
+    public void tick()
+    {
+        if (ticksRan == 0){
+            ticksRan = worldObj.rand.nextInt(360);
+        }
+        ticksRan++;
+    }
+    public boolean setFilterItem(EntityPlayer player, @Nullable ItemStack stack){
+        boolean flag = false;
+        boolean wasNull = filterItem == null;
+        if (filterItem != null && player.getGamemode().consumeBlocks()){
+            player.inventory.insertItem(filterItem, true);
+            flag = true;
+        }
+        if (stack != null) {
+            stack.consumeItem(player);
+            filterItem = new ItemStack(stack.getItem(), 1, stack.getMetadata(), stack.getData());
+            return true;
+        }
+        filterItem = null;
+        return flag | !wasNull;
+    }
+    @Override
+    public void readFromNBT(CompoundTag compoundTag)
+    {
+        super.readFromNBT(compoundTag);
+        if (compoundTag.getBoolean("hasItem")){
+            filterItem = ItemStack.readItemStackFromNbt(compoundTag.getCompound("item"));
+        }
+    }
+
+    @Override
+    public void writeToNBT(CompoundTag compoundTag)
+    {
+        super.writeToNBT(compoundTag);
+        if (filterItem != null){
+            compoundTag.putCompound("item", filterItem.writeToNBT(new CompoundTag()));
+            compoundTag.putBoolean("hasItem", true);
+        }
+    }
+    @Override
+    public Packet getDescriptionPacket() {
+        return new Packet140TileEntityData(this);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/ConsumedFood.java b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
new file mode 100644
index 000000000..920164a73
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.entity;
+
+import net.minecraft.core.item.ItemFood;
+
+public class ConsumedFood {
+    private final EntityLiving entity;
+    private final ItemFood food;
+    private int healRemaining;
+    private int tickCounter = 0;
+
+    public ConsumedFood(EntityLiving entity, ItemFood food) {
+        this.entity = entity;
+        this.food = food;
+
+        this.healRemaining = food.getHealAmount();
+    }
+
+    public void addFood() {
+        healRemaining += food.getHealAmount();
+    }
+
+    public boolean isFinished() {
+        return healRemaining <= 0;
+    }
+
+    public void tick() {
+        if (isFinished()) return;
+
+        tickCounter++;
+        if (tickCounter >= food.getTicksPerHeal()) {
+            tickCounter = 0;
+            healRemaining--;
+            entity.heal(1);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/EntityBobber.java b/src/main/java/net/minecraft/core/entity/EntityBobber.java
index e5d98de10..b85e5663a 100644
--- a/src/main/java/net/minecraft/core/entity/EntityBobber.java
+++ b/src/main/java/net/minecraft/core/entity/EntityBobber.java
@@ -16,27 +16,32 @@ import net.minecraft.core.util.helper.DamageType;
 
 import java.util.List;
 
-// Referenced classes of package net.minecraft.src:
-//            Entity, EntityPlayer, MathHelper, AxisAlignedBB, 
-//            World, ItemStack, Item, Vec3D, 
-//            MovingObjectPosition, Material, NBTTagCompound, EntityItem, 
-//            StatList
-
 public class EntityBobber extends Entity
 {
+    private int xTile;
+    private int yTile;
+    private int zTile;
+    private boolean inGround;
+    public EntityPlayer player;
+    private int ticksInAir;
+    private int ticksCatchable;
+    public Entity hookedEntity;
+    private int field_6388_l;
+    private double field_6387_m;
+    private double field_6386_n;
+    private double field_6385_o;
+    private double field_6384_p;
+    private double field_6383_q;
+    private double velocityX;
+    private double velocityY;
+    private double velocityZ;
 
     public EntityBobber(World world)
     {
         super(world);
-        xTile = -1;
-        yTile = -1;
-        zTile = -1;
-        inTile = 0;
-        inGround = false;
-        shake = 0;
         ticksInAir = 0;
         ticksCatchable = 0;
-        bobber = null;
+        hookedEntity = null;
         setSize(0.25F, 0.25F);
         ignoreFrustumCheck = true;
     }
@@ -51,29 +56,23 @@ public class EntityBobber extends Entity
     public EntityBobber(World world, EntityPlayer entityplayer)
     {
         super(world);
-        xTile = -1;
-        yTile = -1;
-        zTile = -1;
-        inTile = 0;
-        inGround = false;
-        shake = 0;
         ticksInAir = 0;
         ticksCatchable = 0;
-        bobber = null;
+        hookedEntity = null;
         ignoreFrustumCheck = true;
-        angler = entityplayer;
-        angler.fishEntity = this;
+        player = entityplayer;
+        player.bobberEntity = this;
         setSize(0.25F, 0.25F);
         moveTo(entityplayer.x, (entityplayer.y + 1.62D) - (double)entityplayer.heightOffset, entityplayer.z, entityplayer.yRot, entityplayer.xRot);
-        x -= MathHelper.cos((yRot / 180F) * 3.141593F) * 0.16F;
-        y -= 0.10000000149011612D;
-        z -= MathHelper.sin((yRot / 180F) * 3.141593F) * 0.16F;
+        x -= MathHelper.cos((yRot / 180F) * MathHelper.PI) * 0.16F;
+        y -= 0.1D;
+        z -= MathHelper.sin((yRot / 180F) * MathHelper.PI) * 0.16F;
         setPos(x, y, z);
         heightOffset = 0.0F;
         float f = 0.4F;
-        xd = -MathHelper.sin((yRot / 180F) * 3.141593F) * MathHelper.cos((xRot / 180F) * 3.141593F) * f;
-        zd = MathHelper.cos((yRot / 180F) * 3.141593F) * MathHelper.cos((xRot / 180F) * 3.141593F) * f;
-        yd = -MathHelper.sin((xRot / 180F) * 3.141593F) * f;
+        xd = -MathHelper.sin((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
+        zd = MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
+        yd = -MathHelper.sin((xRot / 180F) * MathHelper.PI) * f;
         func_4042_a(xd, yd, zd, 1.5F, 1.0F);
     }
 
@@ -97,9 +96,9 @@ public class EntityBobber extends Entity
         d /= f2;
         d1 /= f2;
         d2 /= f2;
-        d += random.nextGaussian() * 0.0074999998323619366D * (double)f1;
-        d1 += random.nextGaussian() * 0.0074999998323619366D * (double)f1;
-        d2 += random.nextGaussian() * 0.0074999998323619366D * (double)f1;
+        d += random.nextGaussian() * 0.0075D * (double)f1;
+        d1 += random.nextGaussian() * 0.0075D * (double)f1;
+        d2 += random.nextGaussian() * 0.0075D * (double)f1;
         d *= f;
         d1 *= f;
         d2 *= f;
@@ -107,9 +106,8 @@ public class EntityBobber extends Entity
         yd = d1;
         zd = d2;
         float f3 = MathHelper.sqrt_double(d * d + d2 * d2);
-        yRotO = yRot = (float)((java.lang.Math.atan2(d, d2) * 180D) / 3.1415927410125732D);
-        xRotO = xRot = (float)((java.lang.Math.atan2(d1, f3) * 180D) / 3.1415927410125732D);
-        ticksInGround = 0;
+        yRotO = yRot = (float)((Math.atan2(d, d2) * 180D) / Math.PI);
+        xRotO = xRot = (float)((Math.atan2(d1, f3) * 180D) / Math.PI);
     }
 
     @Override
@@ -156,120 +154,107 @@ public class EntityBobber extends Entity
         }
         if(!world.isClientSide)
         {
-            ItemStack itemstack = angler.getCurrentEquippedItem();
-            if(angler.removed || !angler.isAlive() || itemstack == null || itemstack.getItem() != Item.toolFishingrod || distanceToSqr(angler) > 1024D)
+            ItemStack heldPlayerItem = player.getCurrentEquippedItem();
+            if(player.removed || !player.isAlive() || heldPlayerItem == null || heldPlayerItem.getItem() != Item.toolFishingrod || distanceToSqr(player) > 1024D)
             {
                 remove();
-                angler.fishEntity = null;
+                player.bobberEntity = null;
                 return;
             }
-            if(bobber != null)
+            if(hookedEntity != null)
             {
-                if(bobber.removed)
+                if(hookedEntity.removed)
                 {
-                    bobber = null;
+                    hookedEntity = null;
                 } else
                 {
-                    x = bobber.x;
-                    y = bobber.bb.minY + (double)bobber.bbHeight * 0.80000000000000004D;
-                    z = bobber.z;
+                    x = hookedEntity.x;
+                    y = hookedEntity.bb.minY + (double) hookedEntity.bbHeight * 0.8D;
+                    z = hookedEntity.z;
                     return;
                 }
             }
         }
-        if(shake > 0)
-        {
-            shake--;
-        }
-        if(inGround)
-        {
-            int i = world.getBlockId(xTile, yTile, zTile);
-            if(i != inTile)
-            {
+        if (inGround) {
+            if (world.getBlockId(xTile, yTile, zTile) == Block.rope.id) {
+                x = xTile + 0.5D;
+                y = yTile + 0.5D;
+                z = zTile + 0.5D;
+                return;
+            } else {
                 inGround = false;
                 xd *= random.nextFloat() * 0.2F;
                 yd *= random.nextFloat() * 0.2F;
                 zd *= random.nextFloat() * 0.2F;
-                ticksInGround = 0;
                 ticksInAir = 0;
-            } else
-            {
-                ticksInGround++;
-                if(ticksInGround == 1200)
-                {
-                    remove();
-                }
-                return;
+                ticksCatchable = 0;
             }
-        } else
-        {
-            ticksInAir++;
         }
-        Vec3d vec3d = Vec3d.createVector(x, y, z);
-        Vec3d vec3d1 = Vec3d.createVector(x + xd, y + yd, z + zd);
-        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3d, vec3d1);
-        vec3d = Vec3d.createVector(x, y, z);
-        vec3d1 = Vec3d.createVector(x + xd, y + yd, z + zd);
-        if(movingobjectposition != null)
+        ticksInAir++;
+        Vec3d currentPos = Vec3d.createVector(x, y, z);
+        Vec3d nextPos = Vec3d.createVector(x + xd, y + yd, z + zd);
+        HitResult hitResult = world.checkBlockCollisionBetweenPoints(currentPos, nextPos);
+        currentPos = Vec3d.createVector(x, y, z);
+        nextPos = Vec3d.createVector(x + xd, y + yd, z + zd);
+        if(hitResult != null)
         {
-            vec3d1 = Vec3d.createVector(movingobjectposition.location.xCoord, movingobjectposition.location.yCoord, movingobjectposition.location.zCoord);
+            nextPos = Vec3d.createVector(hitResult.location.xCoord, hitResult.location.yCoord, hitResult.location.zCoord);
+            if (hitResult.hitType == HitResult.HitType.TILE && world.getBlockId(hitResult.x, hitResult.y, hitResult.z) == Block.rope.id) {
+                inGround = true;
+                xTile = hitResult.x;
+                yTile = hitResult.y;
+                zTile = hitResult.z;
+            }
         }
         Entity entity = null;
-        List list = world.getEntitiesWithinAABBExcludingEntity(this, bb.addCoord(xd, yd, zd).expand(1.0D, 1.0D, 1.0D));
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.addCoord(xd, yd, zd).expand(1.0D, 1.0D, 1.0D));
         double d3 = 0.0D;
-        for(int j = 0; j < list.size(); j++)
+        for (Entity e : list)
         {
-            Entity entity1 = (Entity)list.get(j);
-            if(!entity1.isPickable() || entity1 == angler && ticksInAir < 5)
-            {
+            if (!e.isPickable() || e == player && ticksInAir < 5) {
                 continue;
             }
             float f2 = 0.3F;
-            AABB axisalignedbb = entity1.bb.expand(f2, f2, f2);
-            HitResult movingobjectposition1 = axisalignedbb.func_1169_a(vec3d, vec3d1);
-            if(movingobjectposition1 == null)
-            {
+            AABB aabb = e.bb.expand(f2, f2, f2);
+            HitResult newHitResult = aabb.func_1169_a(currentPos, nextPos);
+            if (newHitResult == null) {
                 continue;
             }
-            double d6 = vec3d.distanceTo(movingobjectposition1.location);
-            if(d6 < d3 || d3 == 0.0D)
-            {
-                entity = entity1;
+            double d6 = currentPos.distanceTo(newHitResult.location);
+            if (d6 < d3 || d3 == 0.0D) {
+                entity = e;
                 d3 = d6;
             }
         }
 
         if(entity != null)
         {
-            movingobjectposition = new HitResult(entity);
+            hitResult = new HitResult(entity);
         }
-        if(movingobjectposition != null)
+        if(hitResult != null)
         {
-            if(movingobjectposition.entity != null)
+            if(hitResult.entity != null)
             {
-                if(movingobjectposition.entity.hurt(angler, 0, DamageType.COMBAT))
+                if(hitResult.entity.hurt(player, 0, DamageType.COMBAT))
                 {
-                    bobber = movingobjectposition.entity;
+                    hookedEntity = hitResult.entity;
                 }
             }
         }
-        if(inGround)
-        {
-            return;
-        }
         move(xd, yd, zd);
         float f = MathHelper.sqrt_double(xd * xd + zd * zd);
-        yRot = (float)((java.lang.Math.atan2(xd, zd) * 180D) / 3.1415927410125732D);
-        for(xRot = (float)((java.lang.Math.atan2(yd, f) * 180D) / 3.1415927410125732D); xRot - xRotO < -180F; xRotO -= 360F) { }
+        yRot = (float)((java.lang.Math.atan2(xd, zd) * 180D) / Math.PI);
+        for(xRot = (float)((java.lang.Math.atan2(yd, f) * 180D) / Math.PI); xRot - xRotO < -180F; xRotO -= 360F) { }
         for(; xRot - xRotO >= 180F; xRotO += 360F) { }
         for(; yRot - yRotO < -180F; yRotO -= 360F) { }
         for(; yRot - yRotO >= 180F; yRotO += 360F) { }
         xRot = xRotO + (xRot - xRotO) * 0.2F;
         yRot = yRotO + (yRot - yRotO) * 0.2F;
-        float f1 = 0.92F;
+
+        float movementScale = 0.92F;
         if(onGround || horizontalCollision)
         {
-            f1 = 0.5F;
+            movementScale = 0.5F;
         }
         int k = 5;
         double d5 = 0.0D;
@@ -296,16 +281,19 @@ public class EntityBobber extends Entity
                 int rainRate = 0;
                 int algaeRate = 0;
                 if(world.canBlockBeRainedOn(MathHelper.floor_double(x), MathHelper.floor_double(y) + 1, MathHelper.floor_double(z)))
+                {
                     rainRate = 200;
+                }
 
-                if(world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y) + 1, MathHelper.floor_double(z)) == Block.algae.id)
+                if(world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y) + 1, MathHelper.floor_double(z)) == Block.algae.id) {
                     algaeRate = 100;
+                }
                 catchRate = (catchRate - rainRate) - algaeRate;
 
                 if(random.nextInt(catchRate) == 0)
                 {
                     ticksCatchable = random.nextInt(30) + 10;
-                    yd -= 0.20000000298023224D;
+                    yd -= 0.2D;
                     world.playSoundAtEntity(null, this, "random.splash", 0.25F, 1.0F + (random.nextFloat() - random.nextFloat()) * 0.4F);
                     float f3 = MathHelper.floor_double(bb.minY);
                     for(int i1 = 0; (float)i1 < 1.0F + bbWidth * 20F; i1++)
@@ -327,41 +315,29 @@ public class EntityBobber extends Entity
         }
         if(ticksCatchable > 0)
         {
-            yd -= (double)(random.nextFloat() * random.nextFloat() * random.nextFloat()) * 0.20000000000000001D;
+            yd -= (double)(random.nextFloat() * random.nextFloat() * random.nextFloat()) * 0.2D;
         }
         double d7 = d5 * 2D - 1.0D;
-        yd += 0.039999999105930328D * d7;
+        yd += 0.04D * d7;
         if(d5 > 0.0D)
         {
-            f1 = (float)((double)f1 * 0.90000000000000002D);
-            yd *= 0.80000000000000004D;
+            movementScale = (float)((double)movementScale * 0.9D);
+            yd *= 0.8D;
         }
-        xd *= f1;
-        yd *= f1;
-        zd *= f1;
+        xd *= movementScale;
+        yd *= movementScale;
+        zd *= movementScale;
         setPos(x, y, z);
     }
 
     @Override
 	public void addAdditionalSaveData(CompoundTag tag)
     {
-        tag.putShort("xTile", (short)xTile);
-        tag.putShort("yTile", (short)yTile);
-        tag.putShort("zTile", (short)zTile);
-        tag.putShort("inTile", (short)inTile);
-        tag.putByte("shake", (byte)shake);
-        tag.putByte("inGround", (byte)(inGround ? 1 : 0));
     }
 
     @Override
 	public void readAdditionalSaveData(CompoundTag tag)
     {
-        xTile = tag.getShort("xTile");
-        yTile = tag.getShort("yTile");
-        zTile = tag.getShort("zTile");
-        inTile = tag.getShort("inTile") & 0x3fff;
-        shake = tag.getByte("shake") & 0xff;
-        inGround = tag.getByte("inGround") == 1;
     }
 
     @Override
@@ -370,63 +346,62 @@ public class EntityBobber extends Entity
         return 0.0F;
     }
 
-    public int catchFish()
+    public int yoink()
     {
-        byte byte0 = 0;
-        if(bobber != null)
+        int damage = 0;
+
+        if(inGround)
         {
-            double d = angler.x - x;
-            double d2 = angler.y - y;
-            double d4 = angler.z - z;
-            double d6 = MathHelper.sqrt_double(d * d + d2 * d2 + d4 * d4);
-            double d8 = 0.10000000000000001D;
-            bobber.xd += d * d8;
-            bobber.yd += d2 * d8 + (double) MathHelper.sqrt_double(d6) * 0.080000000000000002D;
-            bobber.zd += d4 * d8;
-            byte0 = 3;
-        } else
-        if(ticksCatchable > 0)
+            double dx = x - player.x;
+            double dy = y - player.y;
+            double dz = z - player.z;
+            double distance = MathHelper.sqrt_double(dx * dx + dy * dy + dz * dz);
+            dx /= distance;
+            dy /= distance;
+            dz /= distance;
+            double clamp = 0.6D;
+            dx = MathHelper.clamp(dx, -clamp, clamp);
+            dy = MathHelper.clamp(dy, -clamp, clamp);
+            dz = MathHelper.clamp(dz, -clamp, clamp);
+            double scale = 2D;
+            player.xd += dx * scale;
+            player.yd += dy * scale;
+            player.zd += dz * scale;
+            damage = 5;
+        }
+        if(hookedEntity != null)
+        {
+            double dx = player.x - x;
+            double dy = player.y - y;
+            double dz = player.z - z;
+            double distance = MathHelper.sqrt_double(dx * dx + dy * dy + dz * dz);
+            double scale = 0.1D;
+            hookedEntity.xd += dx * scale;
+            hookedEntity.yd += dy * scale + (double) MathHelper.sqrt_double(distance) * 0.08D;
+            hookedEntity.zd += dz * scale;
+            damage = 3;
+        }
+        else if(ticksCatchable > 0)
         {
             EntityItem entityitem = new EntityItem(world, x, y, z, new ItemStack(Item.foodFishRaw));
-            double d1 = angler.x - x;
-            double d3 = angler.y - y;
-            double d5 = angler.z - z;
-            double d7 = MathHelper.sqrt_double(d1 * d1 + d3 * d3 + d5 * d5);
-            double d9 = 0.10000000000000001D;
-            entityitem.xd = d1 * d9;
-            entityitem.yd = d3 * d9 + (double) MathHelper.sqrt_double(d7) * 0.080000000000000002D;
-            entityitem.zd = d5 * d9;
+            double dx = player.x - x;
+            double dy = player.y - y;
+            double dz = player.z - z;
+            double distance = MathHelper.sqrt_double(dx * dx + dy * dy + dz * dz);
+            double scale = 0.1D;
+            entityitem.xd = dx * scale;
+            entityitem.yd = dy * scale + (double) MathHelper.sqrt_double(distance) * 0.08D;
+            entityitem.zd = dz * scale;
             world.entityJoinedWorld(entityitem);
-            angler.addStat(StatList.fishCaughtStat, 1);
-            byte0 = 1;
+            player.addStat(StatList.fishCaughtStat, 1);
+            damage = 1;
         }
         if(inGround)
         {
-            byte0 = 2;
+            damage = 2;
         }
         remove();
-        angler.fishEntity = null;
-        return byte0;
+        player.bobberEntity = null;
+        return damage;
     }
-
-    private int xTile;
-    private int yTile;
-    private int zTile;
-    private int inTile;
-    private boolean inGround;
-    public int shake;
-    public EntityPlayer angler;
-    private int ticksInGround;
-    private int ticksInAir;
-    private int ticksCatchable;
-    public Entity bobber;
-    private int field_6388_l;
-    private double field_6387_m;
-    private double field_6386_n;
-    private double field_6385_o;
-    private double field_6384_p;
-    private double field_6383_q;
-    private double velocityX;
-    private double velocityY;
-    private double velocityZ;
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityItem.java b/src/main/java/net/minecraft/core/entity/EntityItem.java
index 1f578227a..9a85cadd1 100644
--- a/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -31,7 +31,7 @@ public class EntityItem extends Entity
         super(world);
         age = 0;
         health = 5;
-        field_804_d = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
+        initialRotation = (float)(java.lang.Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
         setPos(d, d1, d2);
@@ -57,7 +57,7 @@ public class EntityItem extends Entity
         super(world);
         age = 0;
         health = 5;
-        field_804_d = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
+        initialRotation = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
     }
@@ -272,7 +272,7 @@ public class EntityItem extends Entity
     public int age;
     public int delayBeforeCanPickup;
     private int health;
-    public float field_804_d;
+    public float initialRotation;
     public int basketPickupDelay = 0;
     public static boolean enableItemClumping = true;
 }
